#!/usr/bin/perl
#
#  Photon API - AlterEgo Fork
#  (C) 2002-2010 Andrew Wyatt, FEWT Software

sub sysexec {
  $execdata=`$_[0]`;
  chomp $execdata;
  return ($execdata);
}

sub doevents {
  if ($atmenu eq "1") {
    unless ($noevents eq "1") {
      getpages();
    }
  }
}

sub errorout {
  cbreak(off);
  logger ("ERROR: ".$_[0]." ".$info{'handle'}." on node ".$info{'node'}." Exiting..");
  writeline("\n".$RED."ERROR: ".$LTB.$_[0]."\nExiting..",1);
  bye();
}

sub colorize {
  if ($info{'ansi'} eq "1") {
    $RST="\e[0m"; $BLK="\e[0;30m"; $RED="\e[0;31m"; $GRN="\e[0;32m"; $BRN="\e[0;33m"; $BLU="\e[0;34m";
    $PPL="\e[0;35m"; $LGR="\e[0;37m"; $GRY="\e[1;30m"; $PNK="\e[1;31m"; $LGN="\e[1;32m"; $YLW="\e[1;33m";
    $ALB="\e[1;34m"; $VLT="\e[1;35m"; $LTB="\e[1;36m"; $WHT="\e[1;37m"; $PBLK="\e[0;30m"; $PRED="\e[0;31m";
    $PGRN="\e[0;32m"; $PBRN="\e[0;33m"; $PBLU="\e[0;34m"; $PPPL="\e[0;35m"; $PLGR="\e[0;37m"; $PGRY="\e[1;30m";
    $PPNK="\e[1;31m"; $PLGN="\e[1;32m"; $PYLW="\e[1;33m"; $PALB="\e[1;34m"; $PVLT="\e[1;35m";
    $PBLU="\e[1;36m"; $PWHT="\e[1;37m";
  } else {
    $RST=""; $BLK=""; $RED=""; $GRN=""; $BRN=""; $BLU="";
    $PPL=""; $LGR=""; $GRY=""; $PNK=""; $LGN=""; $YLW="";
    $ALB=""; $VLT=""; $LTB=""; $WHT=""; $PBLK=""; $PRED="";
    $PGRN=""; $PBRN=""; $PBLU=""; $PPPL=""; $PLGR=""; $PGRY="";
    $PPNK=""; $PLGN=""; $PYLW=""; $PALB=""; $PVLT="";
    $PBLU=""; $PWHT="";
    print "";
  }
}

sub lockfile {
  $tolock=$_[0];
  $lockwait=5;
  while (-e "$tolock.lock") {
    --$lockwait;
    if ($lockwait eq 0) {
      last;
    }
    sleep 1;
  }
  if ($lockwait le 0) {
    logger("$info{'handle'} forced unlock on: $tolock");
    unlink("$tolock.lock");
  }
  open(out,">$tolock.lock");
    print out $info{'handle'};
  close(out);
  chmod 0777,"$tolock.lock";
}

sub unlockfile {
   $tolock=$_[0];
   unlink("$tolock.lock");
}

sub cbreak {
  if ($_[0] eq "on") {
    if ($BSD_STYLE) {
      system "stty -echo cbreak <$mytty >$mytty 2>&1";
    } else {
      system "stty -echo raw opost <$mytty >$mytty 2>&1";
    }
  }
  if ($_[0] eq "off") {
    if ($BSD_STYLE) {
      system "stty echo -cbreak <$mytty >$mytty 2>&1";
    } else {
      system "stty echo -raw <$mytty >$mytty 2>&1";
    }
  }
}

sub waitkey {
  $default=$_[0];
  $key="";
  cbreak(on);
  for (;;) {
    wastart: {
    eval {
      local $SIG{ALRM}=sub{$key="";doevents();goto wastart;};
      alarm $config{'eventdelay'};
      $key = "";
      $key=getc(STDIN);
      doevents();
      alarm 0;
    };
    };

    if ($key ne "") {
      unless ($key eq "\n") {
        print $key;			### Colorize
      } else {
        $key=$default;
        print $key;
      }
      last;
    } else {
      next;
    }
  } 
  return $key;
}

sub writeline {
  print $_[0];
  if ($_[1] eq "1") {
    print "\n";
  }
}

sub getline {
  cbreak("on");
  $input{'type'}=$_[0];
  $input{'length'}=$_[1];
  $input{'text'}=$_[2];
  $result="";
  if ($_[3]) {
    $result=$input{'text'};
    for (1..$input{'length'}) {
      print "\e[0;47;30m ";   ### Add to theme file!
    }
    print "\e[".$input{'length'}."D";
  }
  print $input{'text'};
  for (;;) {
    start: {
    eval {
      local $SIG{ALRM}=sub{$key="";doevents();goto start;};
      alarm $config{'eventdelay'};
      $key="";
      $key=getc(STDIN);
      doevents();
      alarm 0;
    };
    };
    if ($key =~/\n/ || $key =~/\r/) {
      chomp $result;
      $retmsg=$result;
      $result="";
      print $RST;
      unless ($retmsg ne "") {
        print $RST;
      }
      if ($input{'type'} =~/phone/ && length($retmsg) ne $input{'length'}) {
        next;
      }
      if ($input{'type'} =~/dob/ && length($retmsg) ne $input{'length'}) {
        next;
      }
      cbreak(off);
      if ($input{'type'} =~/chat/) {
        print "\e[80D\e[2K";
      } else {
        writeline("\n");
      }
      return ($retmsg);
    }
    if ($key =~/\c?/ || $key =~/\ch/) {
      unless ($result eq "") {
        @parts=split(//,$result);
        $junk=pop(@parts);
        $result=join('',@parts);
        print "\e[1D \e[1D";
      }
      next;
    }
    if ($input{'type'} eq "dob") {
      $input{'length'}=10;
      unless ($key =~/[0-9]/) {
        $key="";
        next;
      }
      if (length($result) eq 1) {
        $key=$key."/";
      }
      if (length($result) eq 2) {
        $key="/".$key;
      }
      if (length($result) eq 4) {
        $key=$key."/";
      }
      if (length($result) eq 5) {
        $key="/".$key;
      }
    }
    if ($input{'type'} eq "phone") {
      $input{'length'}=14;
      unless ($key =~/[0-9]/) {
        $key="";
        next;
      }
      if (length($result) lt 1) {
        $key="(".$key;
      }
      if (length($result) eq 3) {
        $key=$key.")";
      }
      if (length($result) eq 4) {
        $key=")".$key;
      }
      if (length($result) eq 5) {
        $key=" ".$key;
      }
      if (length($result) eq 8) {
        $key=$key."-";
      }
      if (length($result) eq 9) {
        $key="-".$key;
      }
    }
    unless (length($result) eq $input{'length'}) {
      unless ($input{'type'} =~/password/) {
        print $key;
      } elsif ($key ne "") {
        print $config{'passchr'};
      }
      $result=$result.$key;
      if ($input{'type'} =~/chat/) {
        if ($result eq "$config{'help'}") {
          $retmsg=$result;
          $result="";
          writeline("\n");
          return ($retmsg);
        }
      }

    }
  }
}

sub logger {
  system ("logger -p local6.notice -t \"$sysinfo{'host'}\" \"$_[0]\"");
}

return 1;
